# coding: utf-8

"""
    Engines API

    Allow clients to fetch Analytics through APIs.  # noqa: E501

    The version of the OpenAPI document: v2:[pa,spar,vault,pub],v1:[fiab,fi,axp,afi,npo,bpm,fpo]
    Contact: analytics.api.support@factset.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from fds.analyticsapi.engines.configuration import Configuration


class CalculationUnitStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'str',
        'error': 'str',
        'result': 'str',
        'progress': 'str'
    }

    attribute_map = {
        'status': 'status',
        'error': 'error',
        'result': 'result',
        'progress': 'progress'
    }

    def __init__(self, status=None, error=None, result=None, progress=None, local_vars_configuration=None):  # noqa: E501
        """CalculationUnitStatus - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._status = None
        self._error = None
        self._result = None
        self._progress = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if error is not None:
            self.error = error
        if result is not None:
            self.result = result
        if progress is not None:
            self.progress = progress

    @property
    def status(self):
        """Gets the status of this CalculationUnitStatus.  # noqa: E501

        The status of calculation unit.  # noqa: E501

        :return: The status of this CalculationUnitStatus.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CalculationUnitStatus.

        The status of calculation unit.  # noqa: E501

        :param status: The status of this CalculationUnitStatus.  # noqa: E501
        :type: str
        """
        allowed_values = ["Queued", "Executing", "Success", "Failed", "Cancelled"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def error(self):
        """Gets the error of this CalculationUnitStatus.  # noqa: E501

        The error in a calculation unit.  # noqa: E501

        :return: The error of this CalculationUnitStatus.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this CalculationUnitStatus.

        The error in a calculation unit.  # noqa: E501

        :param error: The error of this CalculationUnitStatus.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def result(self):
        """Gets the result of this CalculationUnitStatus.  # noqa: E501

        The result URL of the calculation.  # noqa: E501

        :return: The result of this CalculationUnitStatus.  # noqa: E501
        :rtype: str
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this CalculationUnitStatus.

        The result URL of the calculation.  # noqa: E501

        :param result: The result of this CalculationUnitStatus.  # noqa: E501
        :type: str
        """

        self._result = result

    @property
    def progress(self):
        """Gets the progress of this CalculationUnitStatus.  # noqa: E501

        The progress of the calculation unit.  # noqa: E501

        :return: The progress of this CalculationUnitStatus.  # noqa: E501
        :rtype: str
        """
        return self._progress

    @progress.setter
    def progress(self, progress):
        """Sets the progress of this CalculationUnitStatus.

        The progress of the calculation unit.  # noqa: E501

        :param progress: The progress of this CalculationUnitStatus.  # noqa: E501
        :type: str
        """

        self._progress = progress

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalculationUnitStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalculationUnitStatus):
            return True

        return self.to_dict() != other.to_dict()
