# coding: utf-8

"""
    Engines API

    Allow clients to fetch Analytics through APIs.  # noqa: E501

    The version of the OpenAPI document: v2:[pa,spar,vault,pub],v1:[fiab,fi,axp,afi,npo,bpm,fpo]
    Contact: analytics.api.support@factset.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from fds.analyticsapi.engines.configuration import Configuration


class FIJobSettings(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'yield_curve_date': 'str',
        'partial_duration_months': 'list[int]'
    }

    attribute_map = {
        'yield_curve_date': 'yieldCurveDate',
        'partial_duration_months': 'partialDurationMonths'
    }

    def __init__(self, yield_curve_date=None, partial_duration_months=None, local_vars_configuration=None):  # noqa: E501
        """FIJobSettings - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._yield_curve_date = None
        self._partial_duration_months = None
        self.discriminator = None

        self.yield_curve_date = yield_curve_date
        if partial_duration_months is not None:
            self.partial_duration_months = partial_duration_months

    @property
    def yield_curve_date(self):
        """Gets the yield_curve_date of this FIJobSettings.  # noqa: E501


        :return: The yield_curve_date of this FIJobSettings.  # noqa: E501
        :rtype: str
        """
        return self._yield_curve_date

    @yield_curve_date.setter
    def yield_curve_date(self, yield_curve_date):
        """Sets the yield_curve_date of this FIJobSettings.


        :param yield_curve_date: The yield_curve_date of this FIJobSettings.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and yield_curve_date is None:  # noqa: E501
            raise ValueError("Invalid value for `yield_curve_date`, must not be `None`")  # noqa: E501

        self._yield_curve_date = yield_curve_date

    @property
    def partial_duration_months(self):
        """Gets the partial_duration_months of this FIJobSettings.  # noqa: E501


        :return: The partial_duration_months of this FIJobSettings.  # noqa: E501
        :rtype: list[int]
        """
        return self._partial_duration_months

    @partial_duration_months.setter
    def partial_duration_months(self, partial_duration_months):
        """Sets the partial_duration_months of this FIJobSettings.


        :param partial_duration_months: The partial_duration_months of this FIJobSettings.  # noqa: E501
        :type: list[int]
        """

        self._partial_duration_months = partial_duration_months

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FIJobSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FIJobSettings):
            return True

        return self.to_dict() != other.to_dict()
